<?php defined('SYSPATH') or die('No direct script access.');

class Model_Support extends Model
{
    // return request ID
    public static function newRequest($accountID, $description, $title, $isImg) {
        $sql = "SELECT `CreateRequest`(0, :account, :title, :description, :isImg) AS 'Num';";
        return DB::query(Database::SELECT, $sql)
            ->param(':account', (int) $accountID)
            ->param(':description', $description)
            ->param(':title', $title)
            ->param(':isImg', $isImg)
            ->execute()->get('Num');
    }

    // returns status code
    public static function updateRequest($requestID, $accountID, $description, $title) {
        $sql = "SELECT `CreateRequest`(:requestID, :account, :title, :description, :isImg) AS 'Num';";
        return DB::query(Database::SELECT, $sql)
            ->param(':requestID', (int) $requestID)
            ->param(':account', (int) $accountID)
            ->param(':description', $description)
            ->param(':title', $title)
            ->param(':isImg', true)
            ->execute()->get('Num');
    }

    public static function getReports($userID, $offset = 0, $count = 1000, $statusFilter = 'all') {
        $query = 'CALL `GetRequests`(:offset, :count, :account, :filter)';
        return DB::query(Database::SELECT, $query)
            ->param(':account', $userID)
            ->param(':offset', $offset)
            ->param(':count', $count)
            ->param(':filter', $statusFilter)
            ->execute()->as_array();
    }
}
